#include <string>
#include <iostream>
#include <Carbon/Carbon.h>
#include <AddressBook/ABAddressBookC.h>

using namespace std;

string CFStringGetCPPString(CFStringRef _cfString);

int main()
{
		string a = CFStringGetCPPString(ABCopyLocalizedPropertyOrLabel(kABEmailHomeLabel));
		cout << a << "\n";

		return 0;
}

string CFStringGetCPPString(CFStringRef _cfString)
{
	/* Get the length, and make sure that there is actually a string
	 * here.
	 */
	CFIndex stringLen = CFStringGetLength(_cfString);
	CFIndex stringSize = CFStringGetMaximumSizeForEncoding(stringLen, kCFStringEncodingUTF8);
	char *cString;
	string cppString;
	if(stringLen != 0)
	{

		/* Get a char * version of the string... I still have not
		 * figured out the exact size to expect from the
		 * CFStringGetCString method, so I add extra just to be safe.
		 */
		cString = (char *) malloc(stringSize);
		CFStringGetCString(_cfString, cString, stringSize, kCFStringEncodingUTF8);
		cppString = string(cString);
		free(cString);
	}
	return cppString;
}

